/*
   See pages 176-179, Figure 6.16, from "Principles of Parallel Programming".
*/

void InitializeData(double*** new_p, double*** val_p, int n)
{
   int i, j;

   /* allocate storage */
   double** new = (double**)malloc( n*sizeof(double*) );
   double** val = (double**)malloc( n*sizeof(double*) );
   for(i = 0; i < n; i++)
   {
      new[i] = (double*)malloc( n*sizeof(double) );
      val[i] = (double*)malloc( n*sizeof(double) );
   }

   /* initialize to 0.0 except to 1.0 along the left boundary */
   for(i = 0; i < n; i++)
   {
      val[i][0] = 1.0;
      new[i][0] = 1.0;
   }
   for(i = 0; i < n; i++)
   {
      for(j = 1; j < n; j++)
      {
         val[i][j] = 0.0;
         new[i][j] = 0.0;
      }
   }
   *new_p = new;
   *val_p = val;
}/* InitializeData() */