/*
   See pages 176-179, Figure 6.16, from "Principles of Parallel Programming".
*/

void InitializeData(double*** new_p, double*** val_p, int n)
{
   int i, j;
   double** val;
   double** new;

   /* allocate storage */
   val = (double**)malloc( n*sizeof(double*) );
   for(i = 0; i < n; i++)
   {
      val[i] = (double*)malloc( n*sizeof(double) );
   }
   /* initialize to 0.0 */
   for(i = 0; i < n; i++)
   {
      for(j = 0; j < n; j++)
      {
         val[i][j] = 0.0;
      }
   }
   /* now put in boundary conditions */
   for(i = 0; i < (n/11); i++)
   {
      // left edge
      val[i][0] = 1.0;
      val[(5*n/11)+i][0] = 1.0;
      val[n-1-i][0] = 1.0;
      // right edge
      val[i][n-1] = 1.0;
      val[(5*n/11)+i][n-1] = 1.0;
      val[n-1-i][n-1] = 1.0;
      // top edge
      val[0][i] = 1.0;
      val[0][(5*n/11)+i] = 1.0;
      val[0][n-1-i] = 1.0;
      // bottom edge
      val[n-1][i] = 1.0;
      val[n-1][(5*n/11)+i] = 1.0;
      val[n-1][n-1-i] = 1.0;
   }

   /* make array new a copy of array val */
   new = (double**)malloc( n*sizeof(double*) );
   for(i = 0; i < n; i++)
      new[i] = (double*)malloc( n*sizeof(double) );
   for(i = 0; i < n; i++)
      for(j = 0; j < n; j++)
         new[i][j] = val[i][j];

   *new_p = new;
   *val_p = val;
}/* InitializeData() */